package com.lantone.qc.trans.taizhou;

import com.google.common.collect.Lists;
import com.lantone.qc.dbanaly.facade.taizhou.TzXmlUtil;
import com.lantone.qc.pub.model.doc.ReasonableDiagnosisDoc;
import com.lantone.qc.pub.model.vo.MedrecVo;
import com.lantone.qc.pub.util.FastJsonUtils;
import com.lantone.qc.trans.ModelDocTrans;
import com.lantone.qc.trans.comsis.OrdinaryAssistant;

import java.util.List;
import java.util.Map;

/**
 * @Description: 诊疗合理性文档生成
 * @author: rengb
 * @time: 2020/3/17 13:27
 */
public class TaiZhouReasonableDiagnosisDocTrans extends ModelDocTrans {

    @Override
    public List<ReasonableDiagnosisDoc> extract(MedrecVo medrecVo) {
        List<ReasonableDiagnosisDoc> retList = Lists.newArrayList();
        List<Map<String, Object>> contentMaps = (List) medrecVo.getContent().get("content");
        contentMaps.forEach(contentMap -> {
            retList.add(getReasonableDiagnosisDoc(contentMap));
        });
        return retList;
    }

    private ReasonableDiagnosisDoc getReasonableDiagnosisDoc(Map<String, Object> contentMap) {
        String content = contentMap.get("xmlText").toString();
        Map<String, String> structureMap = null;
        if (contentMap.get("isParsed") != null && "1".equals(contentMap.get("isParsed").toString())) {
            structureMap = (Map) FastJsonUtils.getJsonToMap(content);
        } else {
            Map<String, String> sourceMap = TzXmlUtil.getXmlToMapForTZ(content);
            sourceMap.put("mode_id=" + contentMap.get("modeId").toString(), "");
            sourceMap.put("rec_title=" + contentMap.get("recTitle").toString(), "");
            structureMap = OrdinaryAssistant.mapKeyContrast(sourceMap, keyContrasts);
        }
        ReasonableDiagnosisDoc reasonableDiagnosisDoc = new ReasonableDiagnosisDoc();
        reasonableDiagnosisDoc.setStructureMap(structureMap);

        return reasonableDiagnosisDoc;
    }

    private List<String> keyContrasts = Lists.newArrayList();

}